Create PlanTemplate
Create a new PlanTemplate.
This endpoint creates a new PlanTemplate within a specific Organization, identified by its unique UUID. The request body should contain the necessary information for the new PlanTemplate.
Authorizations
m3ter supports machine to machine authentication using the clientCredentials OAuth2 flow.
The authorizationCode flow controls access for human users via the m3ter Console application.
Path Parameters
UUID of the organization. The Organization represents your company as a direct customer of our service.
Body
The unique identifier (UUID) of the Product associated with this PlanTemplate.
36Descriptive name for the PlanTemplate.
1 - 200The ISO currency code for the currency used to charge end users - for example USD, GBP, EUR. This defines the pricing currency and is inherited by any Plans based on the Plan Template.
Notes:
- You can define a currency at Organization-level or Account-level to be used as the billing currency. This can be a different currency to that used for the Plan as the pricing currency.
- If the billing currency for an Account is different to the pricing currency used by a Plan attached to the Account, you must ensure a currency conversion rate is defined for your Organization to convert the pricing currency into the billing currency at billing, otherwise Bills will fail for the Account.
- To define any required currency conversion rates, use the
currencyConversionsrequest body parameter for the Update OrganizationConfig call.
3The fixed charge (standing charge) applied to customer bills. This charge is prorated and must be a non-negative number.
x >= 0Determines the frequency at which bills are generated.
-
Daily. Starting at midnight each day, covering the twenty-four hour period following.
-
Weekly. Starting at midnight on a Monday, covering the seven-day period following.
-
Monthly. Starting at midnight on the first day of each month, covering the entire calendar month following.
-
Annually. Starting at midnight on first day of each year covering the entire calendar year following.
DAILY, WEEKLY, MONTHLY, ANNUALLY, AD_HOC, MIXED The version number of the entity:
- Create entity: Not valid for initial insertion of new entity - do not use for Create. On initial Create, version is set at 1 and listed in the response.
- Update Entity: On Update, version is required and must match the existing version because a check is performed to ensure sequential versioning is preserved. Version is incremented by 1 and listed in the response.
User defined fields enabling you to attach custom data. The value for a custom field can be either a string or a number.
If customFields can also be defined for this entity at the Organizational level, customField values defined at individual level override values of customFields with the same name defined at Organization level.
See Working with Custom Fields in the m3ter documentation for more information.
Standing charge description (displayed on the bill line item).
200How often the standing charge is applied.
For example, if the bill is issued every three months and standingChargeInterval is 2, then the standing charge is applied every six months.
1 <= x <= 365Defines an offset for when the standing charge is first applied.
For example, if the bill is issued every three months and the standingChargeOfset is 0, then the charge is applied to the first bill (at three months); if 1, it would be applied to the second bill (at six months), and so on.
0 <= x <= 364How often bills are issued.
For example, if billFrequency is Monthly and billFrequencyInterval is 3, bills are issued every three months.
1 <= x <= 365The ranking of the PlanTemplate among your pricing plans. Lower numbers represent more basic plans, while higher numbers represent premium plans. This must be a non-negative integer.
NOTE: DEPRECATED - do not use.
x >= 0A unique, short code reference for the PlanTemplate. This code should not contain control characters or spaces.
80^([^[\p{Cntrl}\s]])|([^[\p{Cntrl}\s]][[^[\p{Cntrl}\s]] ]*[^[\p{Cntrl}\s]])$The Product minimum spend amount per billing cycle for end customer Accounts on a pricing Plan based on the PlanTemplate. This must be a non-negative number.
x >= 0Minimum spend description (displayed on the bill line item).
200A boolean that determines when the standing charge is billed.
- TRUE - standing charge is billed at the start of each billing period.
- FALSE - standing charge is billed at the end of each billing period.
Overrides the setting at Organizational level for standing charge billing in arrears/in advance.
A boolean that determines when the minimum spend is billed.
- TRUE - minimum spend is billed at the start of each billing period.
- FALSE - minimum spend is billed at the end of each billing period.
Overrides the setting at Organizational level for minimum spend billing in arrears/in advance.
Response
Returns the created PlanTemplate
The UUID of the entity.
The version number:
- Create: On initial Create to insert a new entity, the version is set at 1 in the response.
- Update: On successful Update, the version is incremented by 1 in the response.
User defined fields enabling you to attach custom data. The value for a custom field can be either a string or a number.
If customFields can also be defined for this entity at the Organizational level,customField values defined at individual level override values of customFields with the same name defined at Organization level.
See Working with Custom Fields in the m3ter documentation for more information.
The unique identifier (UUID) of the Product associated with this PlanTemplate.
Descriptive name for the PlanTemplate.
The ISO currency code for the pricing currency used by Plans based on the Plan Template to define charge rates for Product consumption - for example USD, GBP, EUR.
The fixed charge (standing charge) applied to customer bills. This charge is prorated and must be a non-negative number.
Standing charge description (displayed on the bill line item).
How often the standing charge is applied.
For example, if the bill is issued every three months and standingChargeInterval is 2, then the standing charge is applied every six months.
Defines an offset for when the standing charge is first applied.
For example, if the bill is issued every three months and the standingChargeOfset is 0, then the charge is applied to the first bill (at three months); if 1, it would be applied to the second bill (at six months), and so on.
How often bills are issued.
For example, if billFrequency is Monthly and billFrequencyInterval is 3, bills are issued every three months.
Determines the frequency at which bills are generated.
-
Daily. Starting at midnight each day, covering the twenty-four hour period following.
-
Weekly. Starting at midnight on a Monday, covering the seven-day period following.
-
Monthly. Starting at midnight on the first day of each month, covering the entire calendar month following.
-
Annually. Starting at midnight on first day of each year covering the entire calendar year following.
DAILY, WEEKLY, MONTHLY, ANNUALLY, AD_HOC, MIXED The ranking of the PlanTemplate among your pricing plans. Lower numbers represent more basic plans, while higher numbers represent premium plans. This must be a non-negative integer.
NOTE: DEPRECATED - no longer used.
A unique, short code reference for the PlanTemplate. This code should not contain control characters or spaces.
The Product minimum spend amount per billing cycle for end customer Accounts on a pricing Plan based on the PlanTemplate. This must be a non-negative number.
Minimum spend description (displayed on the bill line item).
A boolean that determines when the standing charge is billed.
- TRUE - standing charge is billed at the start of each billing period.
- FALSE - standing charge is billed at the end of each billing period.
Overrides the setting at Organizational level for standing charge billing in arrears/in advance.
A boolean that determines when the minimum spend is billed.
- TRUE - minimum spend is billed at the start of each billing period.
- FALSE - minimum spend is billed at the end of each billing period.
Overrides the setting at Organizational level for minimum spend billing in arrears/in advance.
The date and time (in ISO-8601 format) when the PlanTemplate was created.
The date and time (in ISO-8601 format) when the PlanTemplate was last modified.
The unique identifier (UUID) of the user who created this PlanTemplate.
The unique identifier (UUID) of the user who last modified this PlanTemplate.